VERSION 4.00
Begin VB.Form Form1 
   Caption         =   "32bit Router Sample"
   ClientHeight    =   4575
   ClientLeft      =   2160
   ClientTop       =   1755
   ClientWidth     =   5790
   BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
      Name            =   "MS Sans Serif"
      Size            =   8.25
      Charset         =   0
      Weight          =   700
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   ForeColor       =   &H00000000&
   Height          =   5265
   Left            =   2100
   LinkMode        =   1  'Source
   LinkTopic       =   "Form1"
   ScaleHeight     =   4575
   ScaleWidth      =   5790
   Top             =   1125
   Width           =   5910
   Begin VB.CommandButton Command1 
      Caption         =   "Exit"
      Height          =   492
      Left            =   3600
      TabIndex        =   2
      Top             =   3360
      Width           =   1692
   End
   Begin VB.CommandButton cGetDesc 
      Caption         =   "Get Part Description"
      Default         =   -1  'True
      Height          =   492
      Left            =   240
      TabIndex        =   1
      Top             =   3360
      Width           =   2412
   End
   Begin VB.TextBox tbQuantity 
      Height          =   612
      Left            =   3480
      TabIndex        =   5
      TabStop         =   0   'False
      Top             =   2520
      Width           =   1932
   End
   Begin VB.TextBox tbDescription 
      Height          =   612
      Left            =   120
      TabIndex        =   4
      TabStop         =   0   'False
      Top             =   2520
      Width           =   2772
   End
   Begin VB.TextBox tbPartNo 
      ForeColor       =   &H00000000&
      Height          =   372
      Left            =   3360
      TabIndex        =   0
      Top             =   1320
      Width           =   1812
   End
   Begin VB.ComboBox cbSysNames 
      Height          =   315
      Left            =   120
      TabIndex        =   3
      Top             =   600
      Width           =   2292
   End
   Begin VB.Label lRouterLoaded 
      Caption         =   "Router is not loaded"
      Height          =   435
      Left            =   1800
      TabIndex        =   6
      Top             =   3960
      Width           =   2325
   End
   Begin VB.Label Label4 
      Caption         =   "Quantity on Hand"
      Height          =   255
      Left            =   3720
      TabIndex        =   10
      Top             =   2160
      Width           =   1695
   End
   Begin VB.Label Label3 
      Caption         =   "Description"
      Height          =   255
      Left            =   720
      TabIndex        =   9
      Top             =   2160
      Width           =   1815
   End
   Begin VB.Label Label1 
      Caption         =   "Enter Part Number   (1-8)"
      Height          =   375
      Left            =   120
      TabIndex        =   8
      Top             =   1320
      Width           =   2895
   End
   Begin VB.Label Label2 
      Caption         =   "Desired System"
      Height          =   255
      Left            =   120
      TabIndex        =   7
      Top             =   240
      Width           =   1455
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuExit 
         Caption         =   "E&xit"
      End
   End
   Begin VB.Menu mnuHelp 
      Caption         =   "&Help"
      Begin VB.Menu mnuAS400Web 
         Caption         =   "AS/400 &Web Sites"
         Begin VB.Menu mnuAS400KDB 
            Caption         =   "AS/400 &Knowledge Database"
         End
         Begin VB.Menu mnuCAHome 
            Caption         =   "Client Access Home Page"
         End
      End
   End
End
Attribute VB_Name = "Form1"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit
'*****************************************************************
'See RTRSAMP.GBL for details on building and using this sample
'*****************************************************************


'*****************************************************************
' Global declarations specific to this sample program            *
'*****************************************************************
Dim gSysName As String * 8
Dim gConvID As Long
Dim gPartNo As String * 5


Private Function Allocate() As Integer
' This function allocates a conversation with AS/400 program
' RTRREQCL in library JDET.
' The conversation has the following characteristics:
'     Mapped conversation
'     271 byte router buffer (minimum required)
'     Sync Level - none
'     No pip data
' If successful, the conversation ID is returned

Dim PipData(1) As Byte
Dim rc As Integer

   PipData(0) = 0         ' This routine sends no pip data
   rc = EHNAPPC_Allocate(hwnd, 271, EHNAPPC_MAPPED, EHNAPPC_SYNCLEVELNONE, _
                        gSysName, "RTRREQCL.JDET", 0, PipData(0), gConvID)
   If rc <> 0 Then
      MsgBox ("Allocate failed with return code " + Str$(rc))
   End If
   Allocate = rc

End Function

Private Sub AsciiToEbcdic(Data() As Byte)
' This routine converts a Byte array from ASCII to EBCDIC
' VB4 and 5:  Should use a byte array - not a string

Dim tlen As Integer
Dim rc As Integer
Dim I As Integer

   tlen = UBound(Data) + 1         ' in:  Sizeof target string
                                   ' out: Number of chars converted
   rc = EHNDT_ASCIIToEBCDIC(hwnd, Data(0), Data(0), tlen, tlen)

End Sub


Private Sub cbSysNames_Click()
    gSysName = cbSysNames.Text
End Sub

Private Sub cGetDesc_Click()
' When this button is clicked, send the part number to the AS/400 application program
' and receive the 70 byte reply.
' If there is no conversation active, it will be allocated at this time.

Dim Header(3) As Byte              ' Formatted header
Dim Record(69) As Byte             ' Record from the AS/400 (ebcdic)
Dim DataToSend(4) As Byte          ' Data to be sent to 400 (ebcdic)
Dim sRecord As String * 70         ' Record from AS/400 (ascii, vbstring)

Dim rc As Integer
Dim GetSend(1) As Byte

   If gConvID = 0 Then             ' If conversation is not active
      rc = Allocate()              ' Allocate a conversation
   End If

   If Not String2Byte(gPartNo, DataToSend) Then ' Part number is the data to be sent
      MsgBox "Error Converting Part Number", , "Rtrsamp32"
      Exit Sub
   End If
    
   Call AsciiToEbcdic(DataToSend)                     ' Convert data to EBCDIC
   If Send(DataToSend) = 0 Then                       ' Send data to the AS/400
      If RecvW(4, Header) = 0 Then                    ' Receive 4 byte header
         If RecvW(70, Record) = 0 Then                ' Receive 70 byte record
            Call EbcdicToAscii(Record)                ' Convert record to ASCII
            rc = Byte2String(Record, sRecord)
            tbDescription.Text = Mid$(sRecord, 1, 25) ' Display description
            tbQuantity.Text = Mid$(sRecord, 26, 5)    ' Display Quantity on hand
            If tbDescription.Text = _
                  "                         " Then    ' If description is blank
               MsgBox Mid$(Record, 31, 40)            ' then there is an error message
            End If
            rc = RecvW(0, GetSend)                    ' Do one more receive to get change
                                                      ' direction indicator (WhatReceived = Send)
         End If
      End If
   End If
    
End Sub

Private Sub Command1_Click()
' If conversation is active, deallocate it

   If gConvID <> 0 Then
      Call Deallocate
   End If
   
Unload Me
End Sub

Private Sub Deallocate()
' This subroutine deallocates the active conversation
' specified in the ConvID global variable

Dim rc As Integer

   rc = EHNAPPC_Deallocate(hwnd, gConvID, EHNAPPC_DEALLOCATESYNCLEVEL)

End Sub

Private Sub EbcdicToAscii(cBuffer() As Byte)
' This routine converts a byte array from EBCDIC to ASCII
' VB 4&%: Use byte array to avoid corruption by unicode string conversion

Dim tlen As Integer
Dim I As Integer
Dim rc As Integer
   
   tlen = UBound(cBuffer) + 1      ' in:  Length of target string
                                   ' out: Number of chars converted
   rc = EHNDT_EBCDICToASCII(hwnd, cBuffer(0), cBuffer(0), tlen, tlen)

End Sub

Private Sub flip(Inum As Long, Snum() As Byte)
' This routine accepts an integer number as input
' and returns a Byte Array that represents that number with the bytes reversed
' This is useful for converting an Integer in intel format to a Integer
' in AS/400 format

Dim iTemp As Integer
         
   Snum(0) = CByte(Inum / &H100)          ' Move first byte to target
   Snum(1) = CByte(Inum Mod &H100)        ' Move second byte to target

End Sub

Private Sub Form_Load()
' At form load time, fill combo box with list if active systems and set
' default system name

Dim SysCount As Long          ' Number of systems
Dim SysBuff As String * 320   ' Allocate buffer for receiving system names (32*10)
Dim DefSysName As String      ' Default system name
Dim rc As Integer
Dim I As Integer

   gConvID = 0                                    ' Initialize conversation ID  (global variable)
   If EHNAPPC_IsRouterLoaded(hwnd) Then               ' Ensure Router is loaded
      lRouterLoaded.Caption = "Router is Loaded"
      If EHNAPPC_QuerySystems(hwnd, _
                              SysCount, _
                              SysBuff) = 0 Then       ' Get list of system names
         For I = 1 To SysCount
            cbSysNames.AddItem _
                  Mid$(SysBuff, ((I * 10) - 9), 10)   ' Put names in Combo Box
         Next I
         Call GetDefSys(DefSysName)                   ' Get Default system name
         gSysName = DefSysName                        ' Set global variable
         cbSysNames.Text = DefSysName                 ' Set Combo box text
      End If
   Else                                               ' If Router not loaded
      lRouterLoaded.Caption = "Router is not Loaded"
      lRouterLoaded.ForeColor = &HC0&
   End If

End Sub

Private Sub GetDefSys(DefSys As String)
' This routine gets the default system into variable DefSys$
   Dim rc As Integer

   DefSys = Space$(10)
   rc = EHNAPPC_GetDefaultSystem(hwnd, DefSys$)

End Sub

Private Function RecvW(Rlen As Long, buff() As Byte) As Integer
' This function Receives data from the Router for the length specified
' and returns it in the byte array specified.

Dim rc As Integer
Dim WhatRec As Byte
Dim Rts As Byte
Dim ActLen As Integer
Dim I As Integer

   rc = EHNAPPC_ReceiveAndWait(hwnd, gConvID, EHNAPPC_BUFFER, _
                               Rlen, buff(0), WhatRec, Rts, ActLen)
   If rc <> 0 Then
      MsgBox ("Receive failed with return code " + Str$(rc))
   Else
      Rlen = ActLen                       ' Return actual length
      'ViewByteArray buff, "Receive String"
   End If
   RecvW = rc                             ' Return return code

End Function

Private Function Send(Sdata() As Byte) As Integer
' This function sends the specified data to the AS/400
' It does not wait for a reply
' The data sent will be preceeded by the proper GDS header (llID)


Dim GDSHdr(3) As Byte         '4 byte GDS Header
Dim FData() As Byte           'Formatted Data (header + data)
Dim Dlen(1) As Byte           '2 byte length of data (AS/400 format)
Dim DataLen As Long           'Length of data being sent (PC format)
Dim rqs As Byte
Dim rc As Integer

Dim I As Integer



   DataLen = Sizeof(Sdata) + 4
   Call flip(DataLen, Dlen)           ' Get length into proper format
   ' Format of mapped GDS header is llID where ID=x'12FF'
   GDSHdr(0) = Dlen(0)
   GDSHdr(1) = Dlen(1)
   GDSHdr(2) = &H12
   GDSHdr(3) = &HFF
   'Add the Data after the header
   FData = GDSHdr
   ReDim Preserve FData(DataLen - 1) As Byte '0 to 8
   For I = 0 To UBound(Sdata)
      FData(I + 4) = Sdata(I)                   ' Put together formatted data
   Next I
   'ViewByteArray FData, "Send Data"            ' Inspect the buffer
   
   rc = EHNAPPC_SendData(hwnd, gConvID, DataLen, FData(0), rqs)
   If rc <> 0 Then
        MsgBox ("Send failed with Return code " + Str$(rc))
    End If
    Send = rc                       ' Return return code

End Function




Private Sub mnuAS400KDB_Click()
   Call DisplayURL("http://www.as400service.ibm.com/as400/service.html")
End Sub

Private Sub mnuCAHome_Click()
   Call DisplayURL("http://www.as400.ibm.com/clientaccess")
End Sub

Private Sub mnuExit_Click()
   Unload Me
End Sub


Private Sub tbPartNo_Change()
' Fill in part number global variable

Dim Ipart As Long

   If Len(tbPartNo.Text) > 0 Then
      Ipart = Val(tbPartNo.Text)
      gPartNo = Format$(Ipart, "00000")   ' Part number must be 5 digits
   End If
 
End Sub

